=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentPackageIndicesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a package index
    # A PackageIndex represents the package indices of a single component-architecture combination.  Associated artifacts: Exactly one 'Packages' file. May optionally include one or more of 'Packages.gz', 'Packages.xz', 'Release'. If included, the 'Release' file is a legacy per-component-and-architecture Release file.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any 'Packages' files it needs when creating the publication. It does not make use of PackageIndex content.
    # @param deb_package_index [DebPackageIndex] 
    # @param [Hash] opts the optional parameters
    # @return [DebPackageIndexResponse]
    def create(deb_package_index, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_package_index, opts)
      data
    end

    # Create a package index
    # A PackageIndex represents the package indices of a single component-architecture combination.  Associated artifacts: Exactly one &#39;Packages&#39; file. May optionally include one or more of &#39;Packages.gz&#39;, &#39;Packages.xz&#39;, &#39;Release&#39;. If included, the &#39;Release&#39; file is a legacy per-component-and-architecture Release file.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any &#39;Packages&#39; files it needs when creating the publication. It does not make use of PackageIndex content.
    # @param deb_package_index [DebPackageIndex] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebPackageIndexResponse, Integer, Hash)>] DebPackageIndexResponse data, response status code and response headers
    def create_with_http_info(deb_package_index, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackageIndicesApi.create ...'
      end
      # verify the required parameter 'deb_package_index' is set
      if @api_client.config.client_side_validation && deb_package_index.nil?
        fail ArgumentError, "Missing the required parameter 'deb_package_index' when calling ContentPackageIndicesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/package_indices/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_package_index) 

      # return_type
      return_type = opts[:return_type] || 'DebPackageIndexResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackageIndicesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List PackageIndices
    # A PackageIndex represents the package indices of a single component-architecture combination.  Associated artifacts: Exactly one 'Packages' file. May optionally include one or more of 'Packages.gz', 'Packages.xz', 'Release'. If included, the 'Release' file is a legacy per-component-and-architecture Release file.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any 'Packages' files it needs when creating the publication. It does not make use of PackageIndex content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :component Filter results where component matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebPackageIndexResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List PackageIndices
    # A PackageIndex represents the package indices of a single component-architecture combination.  Associated artifacts: Exactly one &#39;Packages&#39; file. May optionally include one or more of &#39;Packages.gz&#39;, &#39;Packages.xz&#39;, &#39;Release&#39;. If included, the &#39;Release&#39; file is a legacy per-component-and-architecture Release file.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any &#39;Packages&#39; files it needs when creating the publication. It does not make use of PackageIndex content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :component Filter results where component matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebPackageIndexResponseList, Integer, Hash)>] PaginateddebPackageIndexResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackageIndicesApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/package_indices/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'architecture'] = opts[:'architecture'] if !opts[:'architecture'].nil?
      query_params[:'component'] = opts[:'component'] if !opts[:'component'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebPackageIndexResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackageIndicesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a package index
    # A PackageIndex represents the package indices of a single component-architecture combination.  Associated artifacts: Exactly one 'Packages' file. May optionally include one or more of 'Packages.gz', 'Packages.xz', 'Release'. If included, the 'Release' file is a legacy per-component-and-architecture Release file.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any 'Packages' files it needs when creating the publication. It does not make use of PackageIndex content.
    # @param deb_package_index_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebPackageIndexResponse]
    def read(deb_package_index_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_package_index_href, opts)
      data
    end

    # Inspect a package index
    # A PackageIndex represents the package indices of a single component-architecture combination.  Associated artifacts: Exactly one &#39;Packages&#39; file. May optionally include one or more of &#39;Packages.gz&#39;, &#39;Packages.xz&#39;, &#39;Release&#39;. If included, the &#39;Release&#39; file is a legacy per-component-and-architecture Release file.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any &#39;Packages&#39; files it needs when creating the publication. It does not make use of PackageIndex content.
    # @param deb_package_index_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebPackageIndexResponse, Integer, Hash)>] DebPackageIndexResponse data, response status code and response headers
    def read_with_http_info(deb_package_index_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackageIndicesApi.read ...'
      end
      # verify the required parameter 'deb_package_index_href' is set
      if @api_client.config.client_side_validation && deb_package_index_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_package_index_href' when calling ContentPackageIndicesApi.read"
      end
      # resource path
      local_var_path = '{deb_package_index_href}'.sub('{' + 'deb_package_index_href' + '}', CGI.escape(deb_package_index_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebPackageIndexResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackageIndicesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
