=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentPackagesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [String] :relative_path Path where the artifact is located relative to distributions base_path
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @return [AsyncOperationResponse]
    def create(opts = {})
      data, _status_code, _headers = create_with_http_info(opts)
      data
    end

    # Create a package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [String] :relative_path Path where the artifact is located relative to distributions base_path
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.create ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/packages/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List packages
    # A Package represents a '.deb' binary package.  Associated artifacts: Exactly one '.deb' package file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :auto_built_package Filter results where auto_built_package matches value
    # @option opts [Boolean] :build_essential Filter results where build_essential matches value
    # @option opts [String] :built_using Filter results where built_using matches value
    # @option opts [Boolean] :essential Filter results where essential matches value
    # @option opts [Integer] :installed_size Filter results where installed_size matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :maintainer Filter results where maintainer matches value
    # @option opts [String] :multi_arch Filter results where multi_arch matches value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :origin Filter results where origin matches value
    # @option opts [String] :original_maintainer Filter results where original_maintainer matches value
    # @option opts [String] :package Filter results where package matches value
    # @option opts [String] :priority Filter results where priority matches value
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :section Filter results where section matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :source Filter results where source matches value
    # @option opts [String] :tag Filter results where tag matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebBasePackageResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List packages
    # A Package represents a &#39;.deb&#39; binary package.  Associated artifacts: Exactly one &#39;.deb&#39; package file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :auto_built_package Filter results where auto_built_package matches value
    # @option opts [Boolean] :build_essential Filter results where build_essential matches value
    # @option opts [String] :built_using Filter results where built_using matches value
    # @option opts [Boolean] :essential Filter results where essential matches value
    # @option opts [Integer] :installed_size Filter results where installed_size matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :maintainer Filter results where maintainer matches value
    # @option opts [String] :multi_arch Filter results where multi_arch matches value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :origin Filter results where origin matches value
    # @option opts [String] :original_maintainer Filter results where original_maintainer matches value
    # @option opts [String] :package Filter results where package matches value
    # @option opts [String] :priority Filter results where priority matches value
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :section Filter results where section matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :source Filter results where source matches value
    # @option opts [String] :tag Filter results where tag matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebBasePackageResponseList, Integer, Hash)>] PaginateddebBasePackageResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.list ...'
      end
      allowable_values = ["false", "true"]
      if @api_client.config.client_side_validation && opts[:'build_essential'] && !allowable_values.include?(opts[:'build_essential'])
        fail ArgumentError, "invalid value for \"build_essential\", must be one of #{allowable_values}"
      end
      allowable_values = ["false", "true"]
      if @api_client.config.client_side_validation && opts[:'essential'] && !allowable_values.include?(opts[:'essential'])
        fail ArgumentError, "invalid value for \"essential\", must be one of #{allowable_values}"
      end
      allowable_values = ["allowed", "foreign", "no", "same"]
      if @api_client.config.client_side_validation && opts[:'multi_arch'] && !allowable_values.include?(opts[:'multi_arch'])
        fail ArgumentError, "invalid value for \"multi_arch\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/packages/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'architecture'] = opts[:'architecture'] if !opts[:'architecture'].nil?
      query_params[:'auto_built_package'] = opts[:'auto_built_package'] if !opts[:'auto_built_package'].nil?
      query_params[:'build_essential'] = opts[:'build_essential'] if !opts[:'build_essential'].nil?
      query_params[:'built_using'] = opts[:'built_using'] if !opts[:'built_using'].nil?
      query_params[:'essential'] = opts[:'essential'] if !opts[:'essential'].nil?
      query_params[:'installed_size'] = opts[:'installed_size'] if !opts[:'installed_size'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'maintainer'] = opts[:'maintainer'] if !opts[:'maintainer'].nil?
      query_params[:'multi_arch'] = opts[:'multi_arch'] if !opts[:'multi_arch'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'origin'] = opts[:'origin'] if !opts[:'origin'].nil?
      query_params[:'original_maintainer'] = opts[:'original_maintainer'] if !opts[:'original_maintainer'].nil?
      query_params[:'package'] = opts[:'package'] if !opts[:'package'].nil?
      query_params[:'priority'] = opts[:'priority'] if !opts[:'priority'].nil?
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'section'] = opts[:'section'] if !opts[:'section'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'source'] = opts[:'source'] if !opts[:'source'].nil?
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebBasePackageResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a package
    # A Package represents a '.deb' binary package.  Associated artifacts: Exactly one '.deb' package file.
    # @param deb_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebBasePackageResponse]
    def read(deb_package_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_package_href, opts)
      data
    end

    # Inspect a package
    # A Package represents a &#39;.deb&#39; binary package.  Associated artifacts: Exactly one &#39;.deb&#39; package file.
    # @param deb_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebBasePackageResponse, Integer, Hash)>] DebBasePackageResponse data, response status code and response headers
    def read_with_http_info(deb_package_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.read ...'
      end
      # verify the required parameter 'deb_package_href' is set
      if @api_client.config.client_side_validation && deb_package_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_package_href' when calling ContentPackagesApi.read"
      end
      # resource path
      local_var_path = '{deb_package_href}'.sub('{' + 'deb_package_href' + '}', CGI.escape(deb_package_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebBasePackageResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
