=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentReleaseArchitecturesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a release architecture
    # A ReleaseArchitecture represents a single dpkg architecture string.  Associated artifacts: None; contains only metadata.  Every ReleaseArchitecture is always associated with exactly one Release. This indicates that the release/distribution in question supports this architecture.
    # @param deb_release_architecture [DebReleaseArchitecture] 
    # @param [Hash] opts the optional parameters
    # @return [DebReleaseArchitectureResponse]
    def create(deb_release_architecture, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_release_architecture, opts)
      data
    end

    # Create a release architecture
    # A ReleaseArchitecture represents a single dpkg architecture string.  Associated artifacts: None; contains only metadata.  Every ReleaseArchitecture is always associated with exactly one Release. This indicates that the release/distribution in question supports this architecture.
    # @param deb_release_architecture [DebReleaseArchitecture] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebReleaseArchitectureResponse, Integer, Hash)>] DebReleaseArchitectureResponse data, response status code and response headers
    def create_with_http_info(deb_release_architecture, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseArchitecturesApi.create ...'
      end
      # verify the required parameter 'deb_release_architecture' is set
      if @api_client.config.client_side_validation && deb_release_architecture.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_architecture' when calling ContentReleaseArchitecturesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/release_architectures/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_release_architecture) 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseArchitectureResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseArchitecturesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List release architectures
    # A ReleaseArchitecture represents a single dpkg architecture string.  Associated artifacts: None; contains only metadata.  Every ReleaseArchitecture is always associated with exactly one Release. This indicates that the release/distribution in question supports this architecture.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :release Filter results where release matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebReleaseArchitectureResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List release architectures
    # A ReleaseArchitecture represents a single dpkg architecture string.  Associated artifacts: None; contains only metadata.  Every ReleaseArchitecture is always associated with exactly one Release. This indicates that the release/distribution in question supports this architecture.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :release Filter results where release matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebReleaseArchitectureResponseList, Integer, Hash)>] PaginateddebReleaseArchitectureResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseArchitecturesApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/release_architectures/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'architecture'] = opts[:'architecture'] if !opts[:'architecture'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'release'] = opts[:'release'] if !opts[:'release'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebReleaseArchitectureResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseArchitecturesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a release architecture
    # A ReleaseArchitecture represents a single dpkg architecture string.  Associated artifacts: None; contains only metadata.  Every ReleaseArchitecture is always associated with exactly one Release. This indicates that the release/distribution in question supports this architecture.
    # @param deb_release_architecture_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebReleaseArchitectureResponse]
    def read(deb_release_architecture_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_release_architecture_href, opts)
      data
    end

    # Inspect a release architecture
    # A ReleaseArchitecture represents a single dpkg architecture string.  Associated artifacts: None; contains only metadata.  Every ReleaseArchitecture is always associated with exactly one Release. This indicates that the release/distribution in question supports this architecture.
    # @param deb_release_architecture_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebReleaseArchitectureResponse, Integer, Hash)>] DebReleaseArchitectureResponse data, response status code and response headers
    def read_with_http_info(deb_release_architecture_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseArchitecturesApi.read ...'
      end
      # verify the required parameter 'deb_release_architecture_href' is set
      if @api_client.config.client_side_validation && deb_release_architecture_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_architecture_href' when calling ContentReleaseArchitecturesApi.read"
      end
      # resource path
      local_var_path = '{deb_release_architecture_href}'.sub('{' + 'deb_release_architecture_href' + '}', CGI.escape(deb_release_architecture_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseArchitectureResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseArchitecturesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
