=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentReleaseComponentsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a release component
    # A ReleaseComponent represents a single APT repository component.  Associated artifacts: None; contains only metadata.  Every ReleaseComponent is always associated with exactly one Release. This indicates that the release/distribution in question contains this component.
    # @param deb_release_component [DebReleaseComponent] 
    # @param [Hash] opts the optional parameters
    # @return [DebReleaseComponentResponse]
    def create(deb_release_component, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_release_component, opts)
      data
    end

    # Create a release component
    # A ReleaseComponent represents a single APT repository component.  Associated artifacts: None; contains only metadata.  Every ReleaseComponent is always associated with exactly one Release. This indicates that the release/distribution in question contains this component.
    # @param deb_release_component [DebReleaseComponent] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebReleaseComponentResponse, Integer, Hash)>] DebReleaseComponentResponse data, response status code and response headers
    def create_with_http_info(deb_release_component, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseComponentsApi.create ...'
      end
      # verify the required parameter 'deb_release_component' is set
      if @api_client.config.client_side_validation && deb_release_component.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_component' when calling ContentReleaseComponentsApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/release_components/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_release_component) 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseComponentResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseComponentsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List release components
    # A ReleaseComponent represents a single APT repository component.  Associated artifacts: None; contains only metadata.  Every ReleaseComponent is always associated with exactly one Release. This indicates that the release/distribution in question contains this component.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :component Filter results where component matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :release Filter results where release matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebReleaseComponentResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List release components
    # A ReleaseComponent represents a single APT repository component.  Associated artifacts: None; contains only metadata.  Every ReleaseComponent is always associated with exactly one Release. This indicates that the release/distribution in question contains this component.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :component Filter results where component matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :release Filter results where release matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebReleaseComponentResponseList, Integer, Hash)>] PaginateddebReleaseComponentResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseComponentsApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/release_components/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'component'] = opts[:'component'] if !opts[:'component'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'release'] = opts[:'release'] if !opts[:'release'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebReleaseComponentResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseComponentsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a release component
    # A ReleaseComponent represents a single APT repository component.  Associated artifacts: None; contains only metadata.  Every ReleaseComponent is always associated with exactly one Release. This indicates that the release/distribution in question contains this component.
    # @param deb_release_component_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebReleaseComponentResponse]
    def read(deb_release_component_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_release_component_href, opts)
      data
    end

    # Inspect a release component
    # A ReleaseComponent represents a single APT repository component.  Associated artifacts: None; contains only metadata.  Every ReleaseComponent is always associated with exactly one Release. This indicates that the release/distribution in question contains this component.
    # @param deb_release_component_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebReleaseComponentResponse, Integer, Hash)>] DebReleaseComponentResponse data, response status code and response headers
    def read_with_http_info(deb_release_component_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseComponentsApi.read ...'
      end
      # verify the required parameter 'deb_release_component_href' is set
      if @api_client.config.client_side_validation && deb_release_component_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_component_href' when calling ContentReleaseComponentsApi.read"
      end
      # resource path
      local_var_path = '{deb_release_component_href}'.sub('{' + 'deb_release_component_href' + '}', CGI.escape(deb_release_component_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseComponentResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseComponentsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
