=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentReleasesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a release
    # A Release represents a single APT release/distribution.  Associated artifacts: None; contains only metadata.  Note that in the context of the \"Release content\", the terms \"distribution\" and \"release\" are synonyms. An \"APT repository release/distribution\" is associated with a single 'Release' file below the 'dists/' folder. The \"distribution\" refers to the path between 'dists/' and the 'Release' file. The \"distribution\" could be considered the name of the \"release\". It is often (but not always) equal to the \"codename\" or \"suite\".
    # @param deb_release [DebRelease] 
    # @param [Hash] opts the optional parameters
    # @return [DebReleaseResponse]
    def create(deb_release, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_release, opts)
      data
    end

    # Create a release
    # A Release represents a single APT release/distribution.  Associated artifacts: None; contains only metadata.  Note that in the context of the \&quot;Release content\&quot;, the terms \&quot;distribution\&quot; and \&quot;release\&quot; are synonyms. An \&quot;APT repository release/distribution\&quot; is associated with a single &#39;Release&#39; file below the &#39;dists/&#39; folder. The \&quot;distribution\&quot; refers to the path between &#39;dists/&#39; and the &#39;Release&#39; file. The \&quot;distribution\&quot; could be considered the name of the \&quot;release\&quot;. It is often (but not always) equal to the \&quot;codename\&quot; or \&quot;suite\&quot;.
    # @param deb_release [DebRelease] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebReleaseResponse, Integer, Hash)>] DebReleaseResponse data, response status code and response headers
    def create_with_http_info(deb_release, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleasesApi.create ...'
      end
      # verify the required parameter 'deb_release' is set
      if @api_client.config.client_side_validation && deb_release.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release' when calling ContentReleasesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/releases/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_release) 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleasesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List releases
    # A Release represents a single APT release/distribution.  Associated artifacts: None; contains only metadata.  Note that in the context of the \"Release content\", the terms \"distribution\" and \"release\" are synonyms. An \"APT repository release/distribution\" is associated with a single 'Release' file below the 'dists/' folder. The \"distribution\" refers to the path between 'dists/' and the 'Release' file. The \"distribution\" could be considered the name of the \"release\". It is often (but not always) equal to the \"codename\" or \"suite\".
    # @param [Hash] opts the optional parameters
    # @option opts [String] :codename Filter results where codename matches value
    # @option opts [String] :distribution Filter results where distribution matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :suite Filter results where suite matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebReleaseResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List releases
    # A Release represents a single APT release/distribution.  Associated artifacts: None; contains only metadata.  Note that in the context of the \&quot;Release content\&quot;, the terms \&quot;distribution\&quot; and \&quot;release\&quot; are synonyms. An \&quot;APT repository release/distribution\&quot; is associated with a single &#39;Release&#39; file below the &#39;dists/&#39; folder. The \&quot;distribution\&quot; refers to the path between &#39;dists/&#39; and the &#39;Release&#39; file. The \&quot;distribution\&quot; could be considered the name of the \&quot;release\&quot;. It is often (but not always) equal to the \&quot;codename\&quot; or \&quot;suite\&quot;.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :codename Filter results where codename matches value
    # @option opts [String] :distribution Filter results where distribution matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :suite Filter results where suite matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebReleaseResponseList, Integer, Hash)>] PaginateddebReleaseResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleasesApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/releases/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'codename'] = opts[:'codename'] if !opts[:'codename'].nil?
      query_params[:'distribution'] = opts[:'distribution'] if !opts[:'distribution'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'suite'] = opts[:'suite'] if !opts[:'suite'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebReleaseResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleasesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a release
    # A Release represents a single APT release/distribution.  Associated artifacts: None; contains only metadata.  Note that in the context of the \"Release content\", the terms \"distribution\" and \"release\" are synonyms. An \"APT repository release/distribution\" is associated with a single 'Release' file below the 'dists/' folder. The \"distribution\" refers to the path between 'dists/' and the 'Release' file. The \"distribution\" could be considered the name of the \"release\". It is often (but not always) equal to the \"codename\" or \"suite\".
    # @param deb_release_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebReleaseResponse]
    def read(deb_release_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_release_href, opts)
      data
    end

    # Inspect a release
    # A Release represents a single APT release/distribution.  Associated artifacts: None; contains only metadata.  Note that in the context of the \&quot;Release content\&quot;, the terms \&quot;distribution\&quot; and \&quot;release\&quot; are synonyms. An \&quot;APT repository release/distribution\&quot; is associated with a single &#39;Release&#39; file below the &#39;dists/&#39; folder. The \&quot;distribution\&quot; refers to the path between &#39;dists/&#39; and the &#39;Release&#39; file. The \&quot;distribution\&quot; could be considered the name of the \&quot;release\&quot;. It is often (but not always) equal to the \&quot;codename\&quot; or \&quot;suite\&quot;.
    # @param deb_release_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebReleaseResponse, Integer, Hash)>] DebReleaseResponse data, response status code and response headers
    def read_with_http_info(deb_release_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleasesApi.read ...'
      end
      # verify the required parameter 'deb_release_href' is set
      if @api_client.config.client_side_validation && deb_release_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_href' when calling ContentReleasesApi.read"
      end
      # resource path
      local_var_path = '{deb_release_href}'.sub('{' + 'deb_release_href' + '}', CGI.escape(deb_release_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleasesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
