=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class RepositoriesAptApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an apt repository
    # An AptRepository is the locally stored, Pulp-internal representation of a APT repository.  It may be filled with content via synchronization or content upload to create an AptRepositoryVersion.
    # @param deb_apt_repository [DebAptRepository] 
    # @param [Hash] opts the optional parameters
    # @return [DebAptRepositoryResponse]
    def create(deb_apt_repository, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_apt_repository, opts)
      data
    end

    # Create an apt repository
    # An AptRepository is the locally stored, Pulp-internal representation of a APT repository.  It may be filled with content via synchronization or content upload to create an AptRepositoryVersion.
    # @param deb_apt_repository [DebAptRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebAptRepositoryResponse, Integer, Hash)>] DebAptRepositoryResponse data, response status code and response headers
    def create_with_http_info(deb_apt_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.create ...'
      end
      # verify the required parameter 'deb_apt_repository' is set
      if @api_client.config.client_side_validation && deb_apt_repository.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository' when calling RepositoriesAptApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/deb/apt/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_apt_repository) 

      # return_type
      return_type = opts[:return_type] || 'DebAptRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an apt repository
    # Trigger an asynchronous delete task
    # @param deb_apt_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(deb_apt_repository_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(deb_apt_repository_href, opts)
      data
    end

    # Delete an apt repository
    # Trigger an asynchronous delete task
    # @param deb_apt_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(deb_apt_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.delete ...'
      end
      # verify the required parameter 'deb_apt_repository_href' is set
      if @api_client.config.client_side_validation && deb_apt_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository_href' when calling RepositoriesAptApi.delete"
      end
      # resource path
      local_var_path = '{deb_apt_repository_href}'.sub('{' + 'deb_apt_repository_href' + '}', CGI.escape(deb_apt_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List apt repositorys
    # An AptRepository is the locally stored, Pulp-internal representation of a APT repository.  It may be filled with content via synchronization or content upload to create an AptRepositoryVersion.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebAptRepositoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List apt repositorys
    # An AptRepository is the locally stored, Pulp-internal representation of a APT repository.  It may be filled with content via synchronization or content upload to create an AptRepositoryVersion.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebAptRepositoryResponseList, Integer, Hash)>] PaginateddebAptRepositoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/deb/apt/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebAptRepositoryResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param deb_apt_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def modify(deb_apt_repository_href, repository_add_remove_content, opts = {})
      data, _status_code, _headers = modify_with_http_info(deb_apt_repository_href, repository_add_remove_content, opts)
      data
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param deb_apt_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def modify_with_http_info(deb_apt_repository_href, repository_add_remove_content, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.modify ...'
      end
      # verify the required parameter 'deb_apt_repository_href' is set
      if @api_client.config.client_side_validation && deb_apt_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository_href' when calling RepositoriesAptApi.modify"
      end
      # verify the required parameter 'repository_add_remove_content' is set
      if @api_client.config.client_side_validation && repository_add_remove_content.nil?
        fail ArgumentError, "Missing the required parameter 'repository_add_remove_content' when calling RepositoriesAptApi.modify"
      end
      # resource path
      local_var_path = '{deb_apt_repository_href}modify/'.sub('{' + 'deb_apt_repository_href' + '}', CGI.escape(deb_apt_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_add_remove_content) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#modify\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an apt repository
    # Trigger an asynchronous partial update task
    # @param deb_apt_repository_href [String] 
    # @param patcheddeb_apt_repository [PatcheddebAptRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(deb_apt_repository_href, patcheddeb_apt_repository, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(deb_apt_repository_href, patcheddeb_apt_repository, opts)
      data
    end

    # Update an apt repository
    # Trigger an asynchronous partial update task
    # @param deb_apt_repository_href [String] 
    # @param patcheddeb_apt_repository [PatcheddebAptRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(deb_apt_repository_href, patcheddeb_apt_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.partial_update ...'
      end
      # verify the required parameter 'deb_apt_repository_href' is set
      if @api_client.config.client_side_validation && deb_apt_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository_href' when calling RepositoriesAptApi.partial_update"
      end
      # verify the required parameter 'patcheddeb_apt_repository' is set
      if @api_client.config.client_side_validation && patcheddeb_apt_repository.nil?
        fail ArgumentError, "Missing the required parameter 'patcheddeb_apt_repository' when calling RepositoriesAptApi.partial_update"
      end
      # resource path
      local_var_path = '{deb_apt_repository_href}'.sub('{' + 'deb_apt_repository_href' + '}', CGI.escape(deb_apt_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patcheddeb_apt_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an apt repository
    # An AptRepository is the locally stored, Pulp-internal representation of a APT repository.  It may be filled with content via synchronization or content upload to create an AptRepositoryVersion.
    # @param deb_apt_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebAptRepositoryResponse]
    def read(deb_apt_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_apt_repository_href, opts)
      data
    end

    # Inspect an apt repository
    # An AptRepository is the locally stored, Pulp-internal representation of a APT repository.  It may be filled with content via synchronization or content upload to create an AptRepositoryVersion.
    # @param deb_apt_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebAptRepositoryResponse, Integer, Hash)>] DebAptRepositoryResponse data, response status code and response headers
    def read_with_http_info(deb_apt_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.read ...'
      end
      # verify the required parameter 'deb_apt_repository_href' is set
      if @api_client.config.client_side_validation && deb_apt_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository_href' when calling RepositoriesAptApi.read"
      end
      # resource path
      local_var_path = '{deb_apt_repository_href}'.sub('{' + 'deb_apt_repository_href' + '}', CGI.escape(deb_apt_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebAptRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Sync from remote
    # Trigger an asynchronous task to sync content
    # @param deb_apt_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def sync(deb_apt_repository_href, repository_sync_url, opts = {})
      data, _status_code, _headers = sync_with_http_info(deb_apt_repository_href, repository_sync_url, opts)
      data
    end

    # Sync from remote
    # Trigger an asynchronous task to sync content
    # @param deb_apt_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def sync_with_http_info(deb_apt_repository_href, repository_sync_url, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.sync ...'
      end
      # verify the required parameter 'deb_apt_repository_href' is set
      if @api_client.config.client_side_validation && deb_apt_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository_href' when calling RepositoriesAptApi.sync"
      end
      # verify the required parameter 'repository_sync_url' is set
      if @api_client.config.client_side_validation && repository_sync_url.nil?
        fail ArgumentError, "Missing the required parameter 'repository_sync_url' when calling RepositoriesAptApi.sync"
      end
      # resource path
      local_var_path = '{deb_apt_repository_href}sync/'.sub('{' + 'deb_apt_repository_href' + '}', CGI.escape(deb_apt_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_sync_url) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#sync\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an apt repository
    # Trigger an asynchronous update task
    # @param deb_apt_repository_href [String] 
    # @param deb_apt_repository [DebAptRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(deb_apt_repository_href, deb_apt_repository, opts = {})
      data, _status_code, _headers = update_with_http_info(deb_apt_repository_href, deb_apt_repository, opts)
      data
    end

    # Update an apt repository
    # Trigger an asynchronous update task
    # @param deb_apt_repository_href [String] 
    # @param deb_apt_repository [DebAptRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(deb_apt_repository_href, deb_apt_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesAptApi.update ...'
      end
      # verify the required parameter 'deb_apt_repository_href' is set
      if @api_client.config.client_side_validation && deb_apt_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository_href' when calling RepositoriesAptApi.update"
      end
      # verify the required parameter 'deb_apt_repository' is set
      if @api_client.config.client_side_validation && deb_apt_repository.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_repository' when calling RepositoriesAptApi.update"
      end
      # resource path
      local_var_path = '{deb_apt_repository_href}'.sub('{' + 'deb_apt_repository_href' + '}', CGI.escape(deb_apt_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_apt_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesAptApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
