=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpDebClient
  # A Serializer for InstallerPackage.
  class DebBasePackageResponse
    attr_accessor :pulp_href

    # Timestamp of creation.
    attr_accessor :pulp_created

    # Artifact file representing the physical content
    attr_accessor :artifact

    # Path where the artifact is located relative to distributions base_path
    attr_accessor :relative_path

    # The MD5 checksum if available.
    attr_accessor :md5

    # The SHA-1 checksum if available.
    attr_accessor :sha1

    # The SHA-224 checksum if available.
    attr_accessor :sha224

    # The SHA-256 checksum if available.
    attr_accessor :sha256

    # The SHA-384 checksum if available.
    attr_accessor :sha384

    # The SHA-512 checksum if available.
    attr_accessor :sha512

    attr_accessor :package

    attr_accessor :source

    attr_accessor :version

    attr_accessor :architecture

    attr_accessor :section

    attr_accessor :priority

    attr_accessor :origin

    attr_accessor :tag

    attr_accessor :bugs

    attr_accessor :essential

    attr_accessor :build_essential

    attr_accessor :installed_size

    attr_accessor :maintainer

    attr_accessor :original_maintainer

    attr_accessor :description

    attr_accessor :description_md5

    attr_accessor :homepage

    attr_accessor :built_using

    attr_accessor :auto_built_package

    attr_accessor :multi_arch

    attr_accessor :breaks

    attr_accessor :conflicts

    attr_accessor :depends

    attr_accessor :recommends

    attr_accessor :suggests

    attr_accessor :enhances

    attr_accessor :pre_depends

    attr_accessor :provides

    attr_accessor :replaces

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'pulp_created' => :'pulp_created',
        :'artifact' => :'artifact',
        :'relative_path' => :'relative_path',
        :'md5' => :'md5',
        :'sha1' => :'sha1',
        :'sha224' => :'sha224',
        :'sha256' => :'sha256',
        :'sha384' => :'sha384',
        :'sha512' => :'sha512',
        :'package' => :'package',
        :'source' => :'source',
        :'version' => :'version',
        :'architecture' => :'architecture',
        :'section' => :'section',
        :'priority' => :'priority',
        :'origin' => :'origin',
        :'tag' => :'tag',
        :'bugs' => :'bugs',
        :'essential' => :'essential',
        :'build_essential' => :'build_essential',
        :'installed_size' => :'installed_size',
        :'maintainer' => :'maintainer',
        :'original_maintainer' => :'original_maintainer',
        :'description' => :'description',
        :'description_md5' => :'description_md5',
        :'homepage' => :'homepage',
        :'built_using' => :'built_using',
        :'auto_built_package' => :'auto_built_package',
        :'multi_arch' => :'multi_arch',
        :'breaks' => :'breaks',
        :'conflicts' => :'conflicts',
        :'depends' => :'depends',
        :'recommends' => :'recommends',
        :'suggests' => :'suggests',
        :'enhances' => :'enhances',
        :'pre_depends' => :'pre_depends',
        :'provides' => :'provides',
        :'replaces' => :'replaces'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'pulp_created' => :'DateTime',
        :'artifact' => :'String',
        :'relative_path' => :'String',
        :'md5' => :'String',
        :'sha1' => :'String',
        :'sha224' => :'String',
        :'sha256' => :'String',
        :'sha384' => :'String',
        :'sha512' => :'String',
        :'package' => :'String',
        :'source' => :'String',
        :'version' => :'String',
        :'architecture' => :'String',
        :'section' => :'String',
        :'priority' => :'String',
        :'origin' => :'String',
        :'tag' => :'String',
        :'bugs' => :'String',
        :'essential' => :'String',
        :'build_essential' => :'String',
        :'installed_size' => :'String',
        :'maintainer' => :'String',
        :'original_maintainer' => :'String',
        :'description' => :'String',
        :'description_md5' => :'String',
        :'homepage' => :'String',
        :'built_using' => :'String',
        :'auto_built_package' => :'String',
        :'multi_arch' => :'String',
        :'breaks' => :'String',
        :'conflicts' => :'String',
        :'depends' => :'String',
        :'recommends' => :'String',
        :'suggests' => :'String',
        :'enhances' => :'String',
        :'pre_depends' => :'String',
        :'provides' => :'String',
        :'replaces' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpDebClient::DebBasePackageResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpDebClient::DebBasePackageResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'artifact')
        self.artifact = attributes[:'artifact']
      end

      if attributes.key?(:'relative_path')
        self.relative_path = attributes[:'relative_path']
      end

      if attributes.key?(:'md5')
        self.md5 = attributes[:'md5']
      end

      if attributes.key?(:'sha1')
        self.sha1 = attributes[:'sha1']
      end

      if attributes.key?(:'sha224')
        self.sha224 = attributes[:'sha224']
      end

      if attributes.key?(:'sha256')
        self.sha256 = attributes[:'sha256']
      end

      if attributes.key?(:'sha384')
        self.sha384 = attributes[:'sha384']
      end

      if attributes.key?(:'sha512')
        self.sha512 = attributes[:'sha512']
      end

      if attributes.key?(:'package')
        self.package = attributes[:'package']
      end

      if attributes.key?(:'source')
        self.source = attributes[:'source']
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.key?(:'architecture')
        self.architecture = attributes[:'architecture']
      end

      if attributes.key?(:'section')
        self.section = attributes[:'section']
      end

      if attributes.key?(:'priority')
        self.priority = attributes[:'priority']
      end

      if attributes.key?(:'origin')
        self.origin = attributes[:'origin']
      end

      if attributes.key?(:'tag')
        self.tag = attributes[:'tag']
      end

      if attributes.key?(:'bugs')
        self.bugs = attributes[:'bugs']
      end

      if attributes.key?(:'essential')
        self.essential = attributes[:'essential']
      end

      if attributes.key?(:'build_essential')
        self.build_essential = attributes[:'build_essential']
      end

      if attributes.key?(:'installed_size')
        self.installed_size = attributes[:'installed_size']
      end

      if attributes.key?(:'maintainer')
        self.maintainer = attributes[:'maintainer']
      end

      if attributes.key?(:'original_maintainer')
        self.original_maintainer = attributes[:'original_maintainer']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'description_md5')
        self.description_md5 = attributes[:'description_md5']
      end

      if attributes.key?(:'homepage')
        self.homepage = attributes[:'homepage']
      end

      if attributes.key?(:'built_using')
        self.built_using = attributes[:'built_using']
      end

      if attributes.key?(:'auto_built_package')
        self.auto_built_package = attributes[:'auto_built_package']
      end

      if attributes.key?(:'multi_arch')
        self.multi_arch = attributes[:'multi_arch']
      end

      if attributes.key?(:'breaks')
        self.breaks = attributes[:'breaks']
      end

      if attributes.key?(:'conflicts')
        self.conflicts = attributes[:'conflicts']
      end

      if attributes.key?(:'depends')
        self.depends = attributes[:'depends']
      end

      if attributes.key?(:'recommends')
        self.recommends = attributes[:'recommends']
      end

      if attributes.key?(:'suggests')
        self.suggests = attributes[:'suggests']
      end

      if attributes.key?(:'enhances')
        self.enhances = attributes[:'enhances']
      end

      if attributes.key?(:'pre_depends')
        self.pre_depends = attributes[:'pre_depends']
      end

      if attributes.key?(:'provides')
        self.provides = attributes[:'provides']
      end

      if attributes.key?(:'replaces')
        self.replaces = attributes[:'replaces']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          pulp_created == o.pulp_created &&
          artifact == o.artifact &&
          relative_path == o.relative_path &&
          md5 == o.md5 &&
          sha1 == o.sha1 &&
          sha224 == o.sha224 &&
          sha256 == o.sha256 &&
          sha384 == o.sha384 &&
          sha512 == o.sha512 &&
          package == o.package &&
          source == o.source &&
          version == o.version &&
          architecture == o.architecture &&
          section == o.section &&
          priority == o.priority &&
          origin == o.origin &&
          tag == o.tag &&
          bugs == o.bugs &&
          essential == o.essential &&
          build_essential == o.build_essential &&
          installed_size == o.installed_size &&
          maintainer == o.maintainer &&
          original_maintainer == o.original_maintainer &&
          description == o.description &&
          description_md5 == o.description_md5 &&
          homepage == o.homepage &&
          built_using == o.built_using &&
          auto_built_package == o.auto_built_package &&
          multi_arch == o.multi_arch &&
          breaks == o.breaks &&
          conflicts == o.conflicts &&
          depends == o.depends &&
          recommends == o.recommends &&
          suggests == o.suggests &&
          enhances == o.enhances &&
          pre_depends == o.pre_depends &&
          provides == o.provides &&
          replaces == o.replaces
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, pulp_created, artifact, relative_path, md5, sha1, sha224, sha256, sha384, sha512, package, source, version, architecture, section, priority, origin, tag, bugs, essential, build_essential, installed_size, maintainer, original_maintainer, description, description_md5, homepage, built_using, auto_built_package, multi_arch, breaks, conflicts, depends, recommends, suggests, enhances, pre_depends, provides, replaces].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpDebClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
